commit 8c45ccb0cb20585d5f7dbfbdf63e66319b113256
Author: hrubyjar <jaroslav.hruby@marbes.cz>
Date:   Sat Apr 16 20:04:00 2022 +0200

    Token management implemented, redirections

diff --git a/Backend/Backend/Controllers/AuthController.cs b/Backend/Backend/Controllers/AuthController.cs
index 0157a39..27511da 100644
--- a/Backend/Backend/Controllers/AuthController.cs
+++ b/Backend/Backend/Controllers/AuthController.cs
@@ -24,11 +24,11 @@ public class AuthController : CommonControllerBase
     [HttpPost("/auth/login")]
     [ProducesResponseType((int) HttpStatusCode.OK, Type = typeof(LoginResponse))]
     [ProducesResponseType((int) HttpStatusCode.Forbidden)]
-    public ActionResult<LoginResponse> Login([FromBody] LoginRequest loginData)
+    public ActionResult<LoginResponse> Index([FromBody] LoginRequest loginData)
     {
         try
         {
-            var loginResponse = authService.Login(loginData.Username, loginData.Password);
+            var loginResponse = authService.Index(loginData.Username, loginData.Password);
             if (loginResponse == null)
             {
                 return Forbid();
diff --git a/Backend/Core/Services/AuthService/AuthService.cs b/Backend/Core/Services/AuthService/AuthService.cs
index 4189b7a..71e96aa 100644
--- a/Backend/Core/Services/AuthService/AuthService.cs
+++ b/Backend/Core/Services/AuthService/AuthService.cs
@@ -15,7 +15,7 @@ public class AuthService : IAuthService
         this.jwtUtils = jwtUtils;
     }
 
-    public LoginResponse? Login(string username, string password)
+    public LoginResponse? Index(string username, string password)
     {
         var user = userService.CheckUsernamePassword(username, password);
 
diff --git a/Backend/Core/Services/AuthService/IAuthService.cs b/Backend/Core/Services/AuthService/IAuthService.cs
index 1469ec9..5a9a93a 100644
--- a/Backend/Core/Services/AuthService/IAuthService.cs
+++ b/Backend/Core/Services/AuthService/IAuthService.cs
@@ -5,5 +5,5 @@ namespace Core.Services;
 
 public interface IAuthService
 {
-    public LoginResponse? Login(string username, string password);
+    public LoginResponse? Index(string username, string password);
 }
\ No newline at end of file
diff --git a/webapp/components/common/Auth.tsx b/webapp/components/common/Auth.tsx
new file mode 100644
index 0000000..d1a4a84
--- /dev/null
+++ b/webapp/components/common/Auth.tsx
@@ -0,0 +1,44 @@
+import React, { ReactNode, useContext, useEffect, useState } from 'react';
+import { useRouter } from 'next/router';
+import { LoggedUserContext } from '../../contexts/LoggedUserContext';
+import { ERole } from '../../api';
+
+export default function Auth({
+    minRole,
+    children,
+}: {
+    minRole?: ERole | null;
+    children: ReactNode;
+}) {
+    const { role, tokenExpiration, logout } = useContext(LoggedUserContext);
+    const [clientRender, setClientRender] = useState(false);
+    const router = useRouter();
+
+    function checkRole(): boolean {
+        if (!minRole) {
+            // no role required
+            return true;
+        }
+
+        return role === minRole ?? false;
+    }
+
+    useEffect(() => {
+        setClientRender(true);
+    }, []);
+
+    if (tokenExpiration?.isBefore(new Date())) {
+        // token has expired
+
+        (async () => {
+            await logout();
+            await router.push('/');
+        })();
+    }
+
+    if (clientRender && checkRole()) {
+        return <>{children}</>;
+    }
+
+    return null;
+}
diff --git a/webapp/components/navigation/AdminNavBar.tsx b/webapp/components/navigation/AdminNavBar.tsx
index f9036cc..931a547 100644
--- a/webapp/components/navigation/AdminNavBar.tsx
+++ b/webapp/components/navigation/AdminNavBar.tsx
@@ -1,11 +1,56 @@
-/**
- * Creates a navigation bar of an admin.
- * @returns Navigation bar of an admin.
- */
-export function AdminNavBar() {
+import React, { useCallback, useContext } from 'react';
+import { Menu } from 'antd';
+import { useRouter } from 'next/router';
+import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
+import { LoggedUserContext } from '../../contexts/LoggedUserContext';
+import {
+    faUser,
+    faFileExport,
+    faFileLines,
+    faUsers,
+    faTags,
+    faBookmark,
+} from '@fortawesome/free-solid-svg-icons';
+
+const UserNavBar = () => {
+    const router = useRouter();
+    const { logout } = useContext(LoggedUserContext);
+    const { SubMenu } = Menu;
+
+    const handleLogout = useCallback(() => {
+        logout();
+        router.push('/login');
+    }, [logout, router]);
+
     return (
-        <div>
-            <p>Navigation bar of an admin.</p>
-        </div>
+        <Menu theme="dark" mode="horizontal">
+            <Menu.Item style={{}} key="1" onClick={() => router.push('/documents/admin')}>
+                <FontAwesomeIcon icon={faFileLines} /> Dokumenty
+            </Menu.Item>
+            <Menu.Item style={{}} key="2" onClick={() => router.push('/users')}>
+                <FontAwesomeIcon icon={faUsers} /> Uživatelé
+            </Menu.Item>
+            <Menu.Item style={{}} key="3" onClick={() => router.push('/tags')}>
+                <FontAwesomeIcon icon={faTags} /> Značky
+            </Menu.Item>
+            <Menu.Item style={{}} key="4" onClick={() => router.push('/classes')}>
+                <FontAwesomeIcon icon={faBookmark} /> Třídy
+            </Menu.Item>
+            <Menu.Item style={{}} key="5" onClick={() => router.push('/export')}>
+                <FontAwesomeIcon icon={faFileExport} /> Export
+            </Menu.Item>
+
+            <SubMenu
+                icon={<FontAwesomeIcon icon={faUser} />}
+                key="account"
+                title={'Admin XY'} // TODO show username
+            >
+                <Menu.Item key="setting:2" onClick={() => handleLogout()}>
+                    Odhlásit se
+                </Menu.Item>
+            </SubMenu>
+        </Menu>
     );
-}
+};
+
+export default UserNavBar;
diff --git a/webapp/components/navigation/UserNavBar.tsx b/webapp/components/navigation/UserNavBar.tsx
index e59e350..83b23f0 100644
--- a/webapp/components/navigation/UserNavBar.tsx
+++ b/webapp/components/navigation/UserNavBar.tsx
@@ -1,11 +1,37 @@
-/**
- * Creates a navigation bar of a normal user (annotator).
- * @returns Navigation bar of a user.
- */
-export function UserNavBar() {
+import React, { useCallback, useContext } from 'react';
+import { Menu } from 'antd';
+import { useRouter } from 'next/router';
+import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
+import { faFileLines, faUser } from '@fortawesome/free-solid-svg-icons';
+import { LoggedUserContext } from '../../contexts/LoggedUserContext';
+
+const UserNavBar = () => {
+    const router = useRouter();
+    const { logout } = useContext(LoggedUserContext);
+    const { SubMenu } = Menu;
+
+    const handleLogout = useCallback(() => {
+        logout();
+        router.push('/login');
+    }, [logout, router]);
+
     return (
-        <div>
-            <p>Navigation bar of a normal user.</p>
-        </div>
+        <Menu theme="dark" mode="horizontal">
+            <Menu.Item key="1" onClick={() => router.push('/documents/annotator')}>
+                <FontAwesomeIcon icon={faFileLines} /> Dokumenty
+            </Menu.Item>
+
+            <SubMenu
+                key="account"
+                icon={<FontAwesomeIcon icon={faUser} />}
+                title={'Anotátor XY'} // TODO show username
+            >
+                <Menu.Item key="setting:2" onClick={() => handleLogout()}>
+                    Odhlásit se
+                </Menu.Item>
+            </SubMenu>
+        </Menu>
     );
-}
+};
+
+export default UserNavBar;
diff --git a/webapp/components/types/auth.ts b/webapp/components/types/auth.ts
new file mode 100644
index 0000000..ceab768
--- /dev/null
+++ b/webapp/components/types/auth.ts
@@ -0,0 +1,14 @@
+import { AppProps } from 'next/app';
+import { ERole } from '../../api';
+
+export type SecuredComponent = AppProps['Component'] & {
+    auth: ComponentAuth;
+};
+
+export class ComponentAuth {
+    minRole: ERole | null;
+
+    constructor(minRole: ERole | null = null) {
+        this.minRole = minRole;
+    }
+}
diff --git a/webapp/contexts/LoggedUserContext.tsx b/webapp/contexts/LoggedUserContext.tsx
new file mode 100644
index 0000000..bcd5308
--- /dev/null
+++ b/webapp/contexts/LoggedUserContext.tsx
@@ -0,0 +1,87 @@
+import React, { createContext, useEffect, useState } from 'react';
+import moment, { Moment } from 'moment';
+import { getTokenData, loginUser, logoutUser } from '../utils/login';
+import { useRouter } from 'next/router';
+import { ERole } from '../api';
+
+interface ILoggedUserProvider {
+    login: (email: string, password: string) => Promise<boolean>;
+    logout: () => Promise<boolean>;
+
+    tokenExpiration?: Moment | null;
+    setTokenExpiration?: (newTokenExpiration: Moment | null) => void;
+
+    role?: ERole | undefined;
+    setRole?: (newRoles: ERole | undefined) => void;
+
+    refreshData?: () => Promise<void>;
+}
+
+export const LoggedUserContext = createContext<ILoggedUserProvider>({
+    login: async (username: string, password: string): Promise<boolean> => {
+        return false;
+    },
+    logout: async (): Promise<boolean> => {
+        return false;
+    },
+});
+
+const LoggedUserProvider = (props: { children: any }) => {
+    const [role, setRole] = useState<ERole>();
+    const [tokenExpiration, setTokenExpiration] = useState<Moment | null>(null);
+    const router = useRouter();
+
+    useEffect(() => {
+        loadData();
+    }, []);
+
+    async function loadData() {
+        const tokenData = await getTokenData();
+        if (!tokenData) {
+            setRole(undefined);
+            setTokenExpiration(null);
+        } else {
+            setRole(tokenData.role);
+            setTokenExpiration(moment(tokenData.expiration));
+        }
+    }
+
+    async function login(username: string, password: string): Promise<boolean> {
+        const res = await loginUser(username, password);
+        if (!res) {
+            return false;
+        }
+
+        await loadData();
+
+        return true;
+    }
+
+    async function logout(): Promise<boolean> {
+        const res = await logoutUser();
+
+        if (res) {
+            setRole(undefined);
+        }
+        await router.push('/');
+        return res;
+    }
+
+    return (
+        <LoggedUserContext.Provider
+            value={{
+                tokenExpiration,
+                setTokenExpiration,
+                role,
+                setRole,
+                refreshData: loadData,
+                login,
+                logout,
+            }}
+        >
+            {props.children}
+        </LoggedUserContext.Provider>
+    );
+};
+
+export default LoggedUserProvider;
diff --git a/webapp/controllers.ts b/webapp/controllers.ts
new file mode 100644
index 0000000..d78fc9b
--- /dev/null
+++ b/webapp/controllers.ts
@@ -0,0 +1,17 @@
+import { UserApi, AuthApi, DocumentApi, AnnotationApi, TagApi } from './api';
+import { axios } from './utils/axios';
+import { Configuration } from './api';
+import { getToken } from './utils/login';
+
+let baseURL = 'https://localhost:7241';
+
+const defaultConfig: Configuration = new Configuration({
+    basePath: baseURL,
+    accessToken: getToken,
+});
+
+export const authController = new AuthApi(defaultConfig, baseURL, axios);
+export const userController = new UserApi(defaultConfig, baseURL, axios);
+export const documentController = new DocumentApi(defaultConfig, baseURL, axios);
+export const annotationController = new AnnotationApi(defaultConfig, baseURL, axios);
+export const tagController = new TagApi(defaultConfig, baseURL, axios);
diff --git a/webapp/hooks/index.tsx b/webapp/hooks/index.tsx
new file mode 100644
index 0000000..7f13f4e
--- /dev/null
+++ b/webapp/hooks/index.tsx
@@ -0,0 +1,3 @@
+import useUnauthRedirect from './useUnauthRedirect';
+
+export { useUnauthRedirect };
diff --git a/webapp/hooks/useUnauthRedirect.tsx b/webapp/hooks/useUnauthRedirect.tsx
new file mode 100644
index 0000000..c9d909c
--- /dev/null
+++ b/webapp/hooks/useUnauthRedirect.tsx
@@ -0,0 +1,28 @@
+import { useRouter } from 'next/router';
+import { useEffect } from 'react';
+import { getToken } from '../utils/login';
+
+/**
+ * Performs redirect when user is unauthenticated.
+ * @param path path where to redirect
+ * @returns redirecting?
+ */
+const useUnauthRedirect = (path: string): boolean => {
+    const router = useRouter();
+    let tokenEmpty = false;
+    useEffect(() => {
+        async function checkToken() {
+            const empty = (await getToken()) === '';
+            if (tokenEmpty) {
+                router.push(path);
+            }
+            // eslint-disable-next-line react-hooks/exhaustive-deps
+            tokenEmpty = empty;
+        }
+        checkToken();
+    }, [path, router]);
+
+    return tokenEmpty;
+};
+
+export default useUnauthRedirect;
diff --git a/webapp/layouts/MainLayout.tsx b/webapp/layouts/MainLayout.tsx
index ae5d48b..fa4e08f 100644
--- a/webapp/layouts/MainLayout.tsx
+++ b/webapp/layouts/MainLayout.tsx
@@ -1,8 +1,9 @@
-import { UserNavBar } from '../components/navigation/UserNavBar';
-import { AdminNavBar } from '../components/navigation/AdminNavBar';
 import 'antd/dist/antd.css';
 import styles from '/styles/MainLayout.module.scss';
-import React from 'react';
+import { useContext } from 'react';
+import { LoggedUserContext } from '../contexts/LoggedUserContext';
+import AdminNavBar from '../components/navigation/AdminNavBar';
+import UserNavBar from '../components/navigation/UserNavBar';
 
 /**
  * Creates layout of main screens.
@@ -10,17 +11,17 @@ import React from 'react';
  * @returns The login screen.
  */
 export function MainLayout(props: { children: React.ReactNode }) {
+    const { role } = useContext(LoggedUserContext);
+    const isAdmin = role === 'ADMINISTRATOR';
+    const isAnnotator = role === 'ANNOTATOR';
+
     return (
         <div className={styles.layoutWrapper}>
             <div className={styles.header}>
-                {/**
-                 @todo: Select correct navigation bar
-                 {user && <UserNavBar />}
-                 {admin && <AdminNavBar />}
-                **/}
+                {(isAdmin && <AdminNavBar />) || (isAnnotator && <UserNavBar />)}
             </div>
             <main className={styles.content}>{props.children}</main>
-            <div className={styles.footer}></div>
+            <div className={styles.footer} />
         </div>
     );
 }
diff --git a/webapp/pages/_app.tsx b/webapp/pages/_app.tsx
index 31960e0..67bf03e 100644
--- a/webapp/pages/_app.tsx
+++ b/webapp/pages/_app.tsx
@@ -1,10 +1,35 @@
-import '../styles/globals.css'
-import type {AppProps} from 'next/app'
+// @ts-nocheck
+import '../styles/globals.css';
+import 'bootstrap/dist/css/bootstrap.css';
 
-import 'bootstrap/dist/css/bootstrap.css'
+import type { AppProps } from 'next/app';
+import Head from 'next/head';
+import { SecuredComponent } from '../components/types/auth';
+import LoggedUserProvider from '../contexts/LoggedUserContext';
+import Auth from '../components/common/Auth';
 
-function MyApp({Component, pageProps}: AppProps) {
-    return <Component {...pageProps} />
+function MyApp({
+    Component,
+    pageProps,
+}: {
+    Component: SecuredComponent;
+    pageProps: AppProps['pageProps'];
+}) {
+    return (
+        <LoggedUserProvider>
+            <Head>
+                <link rel="shortcut icon" href={'/favicon.ico'} />
+                <title>Annotation Tool</title>
+            </Head>
+            {Component.auth ? (
+                <Auth minRole={Component.auth?.minRole}>
+                    <Component {...pageProps} />
+                </Auth>
+            ) : (
+                <Component {...pageProps} />
+            )}
+        </LoggedUserProvider>
+    );
 }
 
-export default MyApp
+export default MyApp;
diff --git a/webapp/pages/classes/index.tsx b/webapp/pages/classes/index.tsx
new file mode 100644
index 0000000..8465291
--- /dev/null
+++ b/webapp/pages/classes/index.tsx
@@ -0,0 +1,37 @@
+import 'antd/dist/antd.css';
+import React, { useContext, useEffect } from 'react';
+
+import { useUnauthRedirect } from '../../hooks';
+import { useRouter } from 'next/router';
+import { Typography } from 'antd';
+import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
+import { faBookmark } from '@fortawesome/free-solid-svg-icons';
+import { LoggedUserContext } from '../../contexts/LoggedUserContext';
+import { MainLayout } from '../../layouts/mainLayout';
+
+function ClassesPage() {
+    const redirecting = useUnauthRedirect('/login');
+    const { logout, role } = useContext(LoggedUserContext);
+    const router = useRouter();
+
+    useEffect(() => {
+        if (role !== 'ADMINISTRATOR') {
+            logout();
+            router.push('/login');
+        }
+
+        if (!redirecting) {
+            // TODO load classes
+        }
+    }, [redirecting, role, router]);
+
+    return redirecting || role !== 'ADMINISTRATOR' ? null : (
+        <MainLayout>
+            <Typography.Title level={2}>
+                <FontAwesomeIcon icon={faBookmark} /> Třídy
+            </Typography.Title>
+        </MainLayout>
+    );
+}
+
+export default ClassesPage;
diff --git a/webapp/pages/documents/admin/index.tsx b/webapp/pages/documents/admin/index.tsx
new file mode 100644
index 0000000..ac575ab
--- /dev/null
+++ b/webapp/pages/documents/admin/index.tsx
@@ -0,0 +1,44 @@
+import 'antd/dist/antd.css';
+import React, { useContext, useEffect } from 'react';
+
+import { useUnauthRedirect } from '../../../hooks';
+import { useRouter } from 'next/router';
+import { Button, Typography } from 'antd';
+import { faFileLines } from '@fortawesome/free-solid-svg-icons';
+import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
+import { LoggedUserContext } from '../../../contexts/LoggedUserContext';
+import { MainLayout } from '../../../layouts/mainLayout';
+import { documentController } from '../../../controllers';
+
+function AdminDocumentPage() {
+    const redirecting = useUnauthRedirect('/login');
+    const { logout, role } = useContext(LoggedUserContext);
+    const router = useRouter();
+    useEffect(() => {
+        if (role !== 'ADMINISTRATOR') {
+            logout();
+            router.push('/login');
+        }
+
+        if (!redirecting) {
+            // TODO load documents
+        }
+    }, [logout, redirecting, role, router]);
+
+    const showModal = () => {
+        // TODO show AddDocument component
+    };
+
+    return redirecting || role !== 'ADMINISTRATOR' ? null : (
+        <MainLayout>
+            <Typography.Title level={2}>
+                <FontAwesomeIcon icon={faFileLines} /> Dokumenty
+            </Typography.Title>
+            <Button type={'primary'} onClick={showModal}>
+                Nahrát dokument
+            </Button>
+        </MainLayout>
+    );
+}
+
+export default AdminDocumentPage;
diff --git a/webapp/pages/documents/annotator/index.tsx b/webapp/pages/documents/annotator/index.tsx
new file mode 100644
index 0000000..3fcf314
--- /dev/null
+++ b/webapp/pages/documents/annotator/index.tsx
@@ -0,0 +1,38 @@
+import 'antd/dist/antd.css';
+import React, { useContext, useEffect } from 'react';
+
+import { useUnauthRedirect } from '../../../hooks';
+import { useRouter } from 'next/router';
+import { Layout, Typography } from 'antd';
+import UserNavBar from '../../../components/navigation/userNavBar';
+import { faFileLines } from '@fortawesome/free-solid-svg-icons';
+import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
+import { LoggedUserContext } from '../../../contexts/LoggedUserContext';
+import { MainLayout } from '../../../layouts/mainLayout';
+
+function UserDocumentPage() {
+    const redirecting = useUnauthRedirect('/login');
+    const { logout, role } = useContext(LoggedUserContext);
+    const router = useRouter();
+
+    useEffect(() => {
+        if (role !== 'ANNOTATOR') {
+            logout();
+            router.push('/login');
+        }
+
+        if (!redirecting) {
+            // TODO load documents
+        }
+    }, [logout, redirecting, role, router]);
+
+    return redirecting || role !== 'ANNOTATOR' ? null : (
+        <MainLayout>
+            <Typography.Title level={2}>
+                <FontAwesomeIcon icon={faFileLines} /> Dokumenty
+            </Typography.Title>
+        </MainLayout>
+    );
+}
+
+export default UserDocumentPage;
diff --git a/webapp/pages/export/index.tsx b/webapp/pages/export/index.tsx
new file mode 100644
index 0000000..1f533b6
--- /dev/null
+++ b/webapp/pages/export/index.tsx
@@ -0,0 +1,33 @@
+import 'antd/dist/antd.css';
+import React, { useContext, useEffect } from 'react';
+
+import { useUnauthRedirect } from '../../hooks';
+import { useRouter } from 'next/router';
+import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
+import { faFileExport } from '@fortawesome/free-solid-svg-icons';
+import { Typography } from 'antd';
+import { LoggedUserContext } from '../../contexts/LoggedUserContext';
+import { MainLayout } from '../../layouts/mainLayout';
+
+function ExportPage() {
+    const redirecting = useUnauthRedirect('/login');
+    const { logout, role } = useContext(LoggedUserContext);
+    const router = useRouter();
+
+    useEffect(() => {
+        if (role !== 'ADMINISTRATOR') {
+            logout();
+            router.push('/login');
+        }
+    }, [logout, redirecting, role, router]);
+
+    return redirecting || role !== 'ADMINISTRATOR' ? null : (
+        <MainLayout>
+            <Typography.Title level={2}>
+                <FontAwesomeIcon icon={faFileExport} /> Export
+            </Typography.Title>
+        </MainLayout>
+    );
+}
+
+export default ExportPage;
diff --git a/webapp/pages/login/index.tsx b/webapp/pages/login/index.tsx
index 4beeb7b..7d492e9 100644
--- a/webapp/pages/login/index.tsx
+++ b/webapp/pages/login/index.tsx
@@ -1,22 +1,44 @@
+import 'antd/dist/antd.css';
 import { Form, Input, Button } from 'antd';
 import { UserOutlined, LockOutlined } from '@ant-design/icons';
-import 'antd/dist/antd.css';
-import { LoginLayout } from '../../layouts/LoginLayout';
+import { LoggedUserContext } from '../../contexts/LoggedUserContext';
+import { LoginLayout } from '../../layouts/loginLayout';
+import { useContext } from 'react';
+import { useRouter } from 'next/router';
+import { ShowToast } from '../../utils/alerts';
+import { getTokenData } from '../../utils/login';
+import { LoginResponse } from '../../api';
 
 /**
  * Creates a login screen.
  * @returns Html structure of the login screen.
  */
 function Login() {
+    const { login, role } = useContext(LoggedUserContext);
+    const router = useRouter();
     /**
      * Handles submission a form when its fields were successfully validated.
      * @param values Fields of the login form.
      */
-    const onFinish = (values: any) => {
-        /**
-         @todo: delete login form log when login API is implemented
-        **/
-        console.log('Values of the login form: ', values);
+    const onFinish = async (values: any) => {
+        const loginRes = await login(values.username, values.password);
+
+        if (!loginRes) {
+            ShowToast(
+                'Chybně zadané heslo nebo uživatelské jméno',
+                'error',
+                3000,
+                'top-end'
+            );
+        } else {
+            let data: LoginResponse | null = await getTokenData();
+            ShowToast('Přihlášení proběhlo úspěšně', 'success', 3000, 'top-end');
+            if (data?.role === 'ADMINISTRATOR') {
+                await router.push('/documents/admin');
+            } else if (data?.role === 'ANNOTATOR') {
+                await router.push('/documents/annotator');
+            }
+        }
     };
 
     /**
@@ -24,10 +46,7 @@ function Login() {
      * @param errorInfo Validation errors.
      */
     const onFinishFailed = (errorInfo: any) => {
-        /**
-         @todo: delete log when error handling is implemented
-        **/
-        console.log('Errors: ', errorInfo);
+        ShowToast('Zadané údaje nejsou validní', 'error', 3000, 'top-end');
     };
 
     return (
diff --git a/webapp/pages/tags/index.tsx b/webapp/pages/tags/index.tsx
new file mode 100644
index 0000000..c304f1f
--- /dev/null
+++ b/webapp/pages/tags/index.tsx
@@ -0,0 +1,33 @@
+import 'antd/dist/antd.css';
+import React, { useContext, useEffect } from 'react';
+
+import { useUnauthRedirect } from '../../hooks';
+import { useRouter } from 'next/router';
+import { Typography } from 'antd';
+import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
+import { faTags } from '@fortawesome/free-solid-svg-icons';
+import { LoggedUserContext } from '../../contexts/LoggedUserContext';
+import { MainLayout } from '../../layouts/mainLayout';
+
+function TagsPage() {
+    const redirecting = useUnauthRedirect('/login');
+    const { logout, role } = useContext(LoggedUserContext);
+    const router = useRouter();
+
+    useEffect(() => {
+        if (role !== 'ADMINISTRATOR') {
+            logout();
+            router.push('/login');
+        }
+    }, [logout, redirecting, role, router]);
+
+    return redirecting || role !== 'ADMINISTRATOR' ? null : (
+        <MainLayout>
+            <Typography.Title level={2}>
+                <FontAwesomeIcon icon={faTags} /> Značky
+            </Typography.Title>
+        </MainLayout>
+    );
+}
+
+export default TagsPage;
diff --git a/webapp/pages/users/index.tsx b/webapp/pages/users/index.tsx
new file mode 100644
index 0000000..2190587
--- /dev/null
+++ b/webapp/pages/users/index.tsx
@@ -0,0 +1,33 @@
+import 'antd/dist/antd.css';
+import React, { useContext, useEffect } from 'react';
+
+import { useUnauthRedirect } from '../../hooks';
+import { useRouter } from 'next/router';
+import { Typography } from 'antd';
+import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
+import { faUsers } from '@fortawesome/free-solid-svg-icons';
+import { LoggedUserContext } from '../../contexts/LoggedUserContext';
+import { MainLayout } from '../../layouts/mainLayout';
+
+function UsersPage() {
+    const redirecting = useUnauthRedirect('/login');
+    const { logout, role } = useContext(LoggedUserContext);
+    const router = useRouter();
+
+    useEffect(() => {
+        if (role !== 'ADMINISTRATOR') {
+            logout();
+            router.push('/login');
+        }
+    }, [logout, redirecting, role, router]);
+
+    return redirecting || role !== 'ADMINISTRATOR' ? null : (
+        <MainLayout>
+            <Typography.Title level={2}>
+                <FontAwesomeIcon icon={faUsers} /> Uživatelé
+            </Typography.Title>
+        </MainLayout>
+    );
+}
+
+export default UsersPage;
diff --git a/webapp/utils/alerts.ts b/webapp/utils/alerts.ts
new file mode 100644
index 0000000..c8c43ab
--- /dev/null
+++ b/webapp/utils/alerts.ts
@@ -0,0 +1,28 @@
+import Swal, { SweetAlertIcon, SweetAlertPosition } from 'sweetalert2';
+import withReactContent from 'sweetalert2-react-content';
+
+const MySwal = withReactContent(Swal);
+
+export function ShowToast(
+    text: string,
+    icon: SweetAlertIcon = 'success',
+    timer = 3000,
+    position: SweetAlertPosition = 'top-right'
+) {
+    const Toast = Swal.mixin({
+        toast: true,
+        position: position,
+        showConfirmButton: false,
+        timer: timer,
+        timerProgressBar: true,
+        didOpen: (toast) => {
+            toast.addEventListener('mouseenter', Swal.stopTimer);
+            toast.addEventListener('mouseleave', Swal.resumeTimer);
+        },
+    });
+
+    Toast.fire({
+        icon: icon,
+        title: text,
+    });
+}
diff --git a/webapp/utils/axios.ts b/webapp/utils/axios.ts
new file mode 100644
index 0000000..6a9e026
--- /dev/null
+++ b/webapp/utils/axios.ts
@@ -0,0 +1,39 @@
+import axiosLib from 'axios';
+import Router from 'next/router';
+import { StatusCodes } from 'http-status-codes';
+import { getToken } from './login';
+
+export const axios = axiosLib.create({
+    baseURL: 'https://localhost:7241',
+    timeout: 60000,
+});
+
+// Add a request interceptor
+axios.interceptors.request.use(async function (config) {
+    const token = await getToken();
+    if (token && config?.headers) {
+        config.headers.Authorization = 'Bearer ' + token;
+    }
+    return config;
+});
+
+// Add a response interceptor
+axios.interceptors.response.use(
+    (response) => response,
+    async function (error) {
+        const status = error?.response?.status;
+        if (status === StatusCodes.UNAUTHORIZED) {
+            console.log('Unauthorized, redirecting...');
+
+            if (Router.pathname !== '/') {
+                await Router.replace({
+                    pathname: '/',
+                });
+            }
+        } else if (status === StatusCodes.FORBIDDEN) {
+            console.log('Forbidden:', error?.response?.config?.url);
+        }
+
+        throw status;
+    }
+);
diff --git a/webapp/utils/login.ts b/webapp/utils/login.ts
new file mode 100644
index 0000000..af3a66e
--- /dev/null
+++ b/webapp/utils/login.ts
@@ -0,0 +1,46 @@
+import { authController } from '../controllers';
+import { LoginResponse } from '../api';
+
+export async function loginUser(username: string, password: string): Promise<boolean> {
+    try {
+        const loginRes = await authController.authLoginPost({ username, password });
+
+        const data: LoginResponse = loginRes.data;
+
+        if (data && data.token) {
+            localStorage.setItem('token', JSON.stringify(data));
+            return true;
+        }
+    } catch (e) {
+        if (e instanceof Error) {
+            if (e.message.includes('status code 401')) {
+                return false;
+            }
+        }
+    }
+
+    return false;
+}
+
+export async function logoutUser(): Promise<boolean> {
+    localStorage.clear();
+    return true;
+}
+export async function getTokenData(): Promise<LoginResponse | null> {
+    const dataJSON = localStorage.getItem('token');
+
+    if (!dataJSON) {
+        // no token found
+        return null;
+    }
+
+    return JSON.parse(dataJSON);
+}
+export async function getToken(): Promise<string> {
+    const data = await getTokenData();
+    if (!data) {
+        return '';
+    }
+
+    return data.token ?? '';
+}
